diff --git a/src/backend/storage/ipc/procarray.c b/src/backend/storage/ipc/procarray.c
index afe1c03aa3..619b80bdaa 100644
--- a/src/backend/storage/ipc/procarray.c
+++ b/src/backend/storage/ipc/procarray.c
@@ -1995,6 +1995,10 @@ GetRunningTransactionData(void)
 		volatile PGXACT *pgxact = &allPgXact[pgprocno];
 		TransactionId xid;
 
+		/* Ignore procs running LAZY VACUUM */
+		if (pgxact->vacuumFlags & PROC_IN_VACUUM)
+			continue;
+
 		/* Fetch xid just once - see GetNewTransactionId */
 		xid = pgxact->xid;
 
